﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.IO;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;

namespace esl
{
    class DownloadDocuments
    {
        public static void main()
        {
            string packageId = "SCcCLU25FgqAdDcJ8Yzombm_v40=";
            string documentId = "13ab5ae288f18709";

            HttpClient client = new HttpClient();
            client.DefaultRequestHeaders.Add("Authorization", "Basic " + Properties.Settings.Default.key);
            client.DefaultRequestHeaders.Add("Accept", "application/pdf");

            // Retrieve the bytes of the document (with fields)
            var firstResponse = client.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId + "/documents/" + documentId + "/pdf")).Result;
            byte[] pdfDocument = firstResponse.Content.ReadAsByteArrayAsync().Result;
            File.WriteAllBytes("C:/Users/hhaidary/Desktop/Example/signed_document.pdf", pdfDocument);

            // Retrieve the bytes of the original document (without fields)
            var secondResponse = client.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId + "/documents/" + documentId + "/original")).Result;
            byte[] originalPdfDocument = secondResponse.Content.ReadAsByteArrayAsync().Result;
            File.WriteAllBytes("C:/Users/hhaidary/Desktop/Example/orignal_document.pdf", originalPdfDocument);

            //Retrieve the bytes of the evidence summary
            var fourthResponse = client.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId + "/evidence/summary")).Result;
            byte[] evidenceDocument = fourthResponse.Content.ReadAsByteArrayAsync().Result;
            File.WriteAllBytes("C:/Users/hhaidary/Desktop/Example/evidence_document.pdf", evidenceDocument);

            // Retrieve the bytes of the zipped file containing all the documents in the package
            client.DefaultRequestHeaders.Remove("Accept");
            client.DefaultRequestHeaders.Add("Accept", "application/zip");
            var thirdResponse = client.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId + "/documents/zip")).Result;
            byte[] zippedPdfDocument = thirdResponse.Content.ReadAsByteArrayAsync().Result;
            File.WriteAllBytes("C:/Users/hhaidary/Desktop/Example/signed_documents.zip", zippedPdfDocument);
 
        }
    }
}
